// DlgConf.cpp : Implementation file
//

#include "stdafx.h"
#include "ClouReaderDemo.h"
#include "DlgConf.h"
#include "afxdialogex.h"


// CDlgConf Dialog box

IMPLEMENT_DYNAMIC(CDlgConf, CDialogEx)

CDlgConf::CDlgConf(CWnd* pParent /*=NULL*/)
	: CDialogEx(CDlgConf::IDD, pParent)
{

}

CDlgConf::~CDlgConf()
{
}

void CDlgConf::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ANT1, m_cAnts[0]);
	DDX_Control(pDX, IDC_ANT2, m_cAnts[1]);
	DDX_Control(pDX, IDC_ANT3, m_cAnts[2]);
	DDX_Control(pDX, IDC_ANT4, m_cAnts[3]);
	DDX_Control(pDX, IDC_ANT5, m_cAnts[4]);
	DDX_Control(pDX, IDC_ANT6, m_cAnts[5]);
	DDX_Control(pDX, IDC_ANT7, m_cAnts[6]);
	DDX_Control(pDX, IDC_ANT8, m_cAnts[7]);
	DDX_Control(pDX, IDC_ANT9, m_cAnts[8]);
	DDX_Control(pDX, IDC_ANT10, m_cAnts[9]);
	DDX_Control(pDX, IDC_ANT11, m_cAnts[10]);
	DDX_Control(pDX, IDC_ANT12, m_cAnts[11]);
	DDX_Control(pDX, IDC_ANT13, m_cAnts[12]);
	DDX_Control(pDX, IDC_ANT14, m_cAnts[13]);
	DDX_Control(pDX, IDC_ANT15, m_cAnts[14]);
	DDX_Control(pDX, IDC_ANT16, m_cAnts[15]);
	DDX_Control(pDX, IDC_ANT17, m_cAnts[16]);
	DDX_Control(pDX, IDC_ANT18, m_cAnts[17]);
	DDX_Control(pDX, IDC_ANT19, m_cAnts[18]);
	DDX_Control(pDX, IDC_ANT20, m_cAnts[19]);
	DDX_Control(pDX, IDC_ANT21, m_cAnts[20]);
	DDX_Control(pDX, IDC_ANT22, m_cAnts[21]);
	DDX_Control(pDX, IDC_ANT23, m_cAnts[22]);
	DDX_Control(pDX, IDC_ANT24, m_cAnts[23]);
	DDX_Control(pDX, IDC_ANT_EDIT1, m_eAnts[0]);
	DDX_Control(pDX, IDC_ANT_EDIT2, m_eAnts[1]);
	DDX_Control(pDX, IDC_ANT_EDIT3, m_eAnts[2]);
	DDX_Control(pDX, IDC_ANT_EDIT4, m_eAnts[3]);
	DDX_Control(pDX, IDC_ANT_EDIT5, m_eAnts[4]);
	DDX_Control(pDX, IDC_ANT_EDIT6, m_eAnts[5]);
	DDX_Control(pDX, IDC_ANT_EDIT7, m_eAnts[6]);
	DDX_Control(pDX, IDC_ANT_EDIT8, m_eAnts[7]);
	DDX_Control(pDX, IDC_ANT_EDIT9, m_eAnts[8]);
	DDX_Control(pDX, IDC_ANT_EDIT10, m_eAnts[9]);
	DDX_Control(pDX, IDC_ANT_EDIT11, m_eAnts[10]);
	DDX_Control(pDX, IDC_ANT_EDIT12, m_eAnts[11]);
	DDX_Control(pDX, IDC_ANT_EDIT13, m_eAnts[12]);
	DDX_Control(pDX, IDC_ANT_EDIT14, m_eAnts[13]);
	DDX_Control(pDX, IDC_ANT_EDIT15, m_eAnts[14]);
	DDX_Control(pDX, IDC_ANT_EDIT16, m_eAnts[15]);
	DDX_Control(pDX, IDC_ANT_EDIT17, m_eAnts[16]);
	DDX_Control(pDX, IDC_ANT_EDIT18, m_eAnts[17]);
	DDX_Control(pDX, IDC_ANT_EDIT19, m_eAnts[18]);
	DDX_Control(pDX, IDC_ANT_EDIT20, m_eAnts[19]);
	DDX_Control(pDX, IDC_ANT_EDIT21, m_eAnts[20]);
	DDX_Control(pDX, IDC_ANT_EDIT22, m_eAnts[21]);
	DDX_Control(pDX, IDC_ANT_EDIT23, m_eAnts[22]);
	DDX_Control(pDX, IDC_ANT_EDIT24, m_eAnts[23]);

	DDX_Control(pDX, IDC_DATETIMEPICKER, m_Time);
}


BEGIN_MESSAGE_MAP(CDlgConf, CDialogEx)
	ON_BN_CLICKED(IDC_SPOWER, &CDlgConf::OnBnClickedSpower)
	ON_BN_CLICKED(IDC_CPOWER, &CDlgConf::OnBnClickedCpower)
	ON_BN_CLICKED(IDC_STIME, &CDlgConf::OnBnClickedStime)
	ON_BN_CLICKED(IDC_CTIME, &CDlgConf::OnBnClickedCtime)
END_MESSAGE_MAP()


// CDlgConf Message handler

BOOL CDlgConf::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  Add additional initialization here
	/*m_cAnt1.SetCheck(1);
	m_cAnt2.SetCheck(1);
	m_cAnt3.EnableWindow(false);
	m_cAnt4.EnableWindow(false);
	m_eAnt3.EnableWindow(false);
	m_eAnt4.EnableWindow(false);*/

	for (int i=0; i<ANT_MAX; i++) {
		m_cAnts[i].EnableWindow(true);
		m_eAnts[i].EnableWindow(true);
		m_cAnts[i].SetCheck(0);
	}

	m_Time.SetFormat("yyyy-MM-dd HH:mm:ss");

	return TRUE;  // return TRUE unless you set the focus to a control
	// Exception: the OCX property page should return FALSE
}

void CDlgConf::OnBnClickedSpower()
{
	// TODO: Add the control notification handler code here
	int power[ANT_MAX];
	CString tmp;
	if (CLGetReaderPower(connStr.GetBuffer(), power, ANT_MAX) == 0)
	{
		GetDlgItem(IDC_POWERSTATUS)->SetWindowText("Get OK");
		for (int i=0; i<ANT_MAX; i++) {
			if (power[i] != -1)
			{
				tmp.Format(_T("%d"), power[i]);
				m_eAnts[i].SetWindowText(tmp);
			} else {
				m_cAnts[i].SetCheck(0);
				m_cAnts[i].EnableWindow(false);
				m_eAnts[i].EnableWindow(false);
			}
		}
	}
	else
	{
		GetDlgItem(IDC_POWERSTATUS)->SetWindowText("Get failed");
	}

}

void CDlgConf::OnBnClickedCpower()
{
	// TODO: Add the control notification handler code here
	int power[ANT_MAX];
	CString tmp;

	for (int i=0; i<ANT_MAX; i++) {
		if (m_cAnts[i].GetCheck())
		{
			m_eAnts[i].GetWindowText(tmp);
			power[i] = atoi(tmp);
		} else {
			power[i] = -1;
		}
	}

	if (CLSetReaderPower(connStr.GetBuffer(), power, ANT_MAX) == 0)
	{
		GetDlgItem(IDC_POWERSTATUS)->SetWindowText("Set OK");
	}
	else
	{
		GetDlgItem(IDC_POWERSTATUS)->SetWindowText("Set failed");
	}
}


void CDlgConf::OnBnClickedStime()
{
	// TODO: Add the control notification handler code here
	unsigned long tmp;
	if (CLGetReaderTime(connStr.GetBuffer(), &tmp, 0) == 0)
	{
		GetDlgItem(IDC_TIMESTATUS)->SetWindowText("Get OK");
		CTime time(tmp);
		m_Time.SetTime(&time);
		
	}
	else
	{
		GetDlgItem(IDC_TIMESTATUS)->SetWindowText("Get failed");
	}

}


void CDlgConf::OnBnClickedCtime()
{
	// TODO: Add the control notification handler code here
	CTime time;
	m_Time.GetTime(time);

	struct tm mytm;
	time.GetLocalTm(&mytm);
	time_t tmp =  mktime(&mytm);
	unsigned long sec = (unsigned long)tmp;

	if (CLSetReaderTime(connStr.GetBuffer(), sec, 0) == 0)
	{
		GetDlgItem(IDC_TIMESTATUS)->SetWindowText("Set OK");
	}
	else
	{
		GetDlgItem(IDC_TIMESTATUS)->SetWindowText("Set failed");
	}
}
